#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <time.h>

#define MAXCOST 99999999999999
#define MAXCAND 10000
#define BADCOST 999999999999

class MatchingDescent{
private:
  // Machines 
  typedef struct  {
  // statique
	  int nei;
	  int loc;
	  long long int *cap;
	  long long int *sfc;
  // dynamique
	  long long int *use;
	  long long int *truse;
	  } machine;

  // Services 
  typedef struct  {
  // statique
	  short nb_maste;
	  short nb_slave;
	  short spreadMin;
	  int *master;
	  int *slaves;
  // dynamique
	  short spread;
  }service;

  // Processus
  typedef struct  {
  // statique
	  int numservice;
	  int movecost;
	  int *req;
	  char indep;
  }processus;

  // Balance Objectives
  typedef struct  {
	  int res1;
	  int res2;
	  int target;
	  int weight;
  } baob;

  // Ressources 
  int nb_rs,nb_rsTr;
  char *is_TR;
  int *weightLoadCost;
  // Machines 
  int nb_mc;
  machine *mac;
  int **MMC;
  int nb_lc;
  int nb_nei;
  // Services 
  int nb_sr;
  service *ser;
  int **sernei,**serloc;
  short *sermov;
  char **sermac;
  // Processus
  int nb_pr;
  processus *pro;
  // Balance Objectives
  int nb_bo;
  baob *bao;
  // Poids Moves
  int weightSMCost,weightPMCost,weightMMCost;
  short *x0,*x;

  unsigned int fscan_next_ill(char *&pb);
  int litjeu(const char *fic);
  int litsolinit(const char *fic);

  void addPM(int p,short m);
  void suppPM(int p,short m);
  void addPM_(int p,short m);
  void suppPM_(int p,short m);  
  int load_PM(int p,short m,long long int &lc);
  int load_PM0(int p,short m,long long int &lc);

  long long int gswap[5000][5000]; 
  int pqswap[5000][5000];          
  char mark[5000][5000];
  int deg[5000];
  short machine1[5000];
  short machine2[5000];
  short match[5001];
  long long int sompoids[5001];
  int nba;  // NUMBER OF EDGES
  void MWM(void);
  void evalsuppPM(int p,short m,long long int &newlc);
  int evalswapM1M2(short m1,short m2,long long int &delta);

  int nb_compatible;
  short *mc1;
  short *mc2;
  long long int *deltac;

  void initcompatible(void);

  int n1,n2,n3; // just for statistics

   int descente(int cpulimit,int &cpu);


  int service_move_max,nb_service_move_max;
  long long int upper_bound;
  long long int *cur_lc;
  long long int sum_move,sum_load;


  int nc_shift;
  long long int sum_shift_min;
  long long int tc1_shift[MAXCAND];
  long long int tc2_shift[MAXCAND];
  int tp_shift[MAXCAND];
  short tm_shift[MAXCAND];

  void eval_move(const int p);

  void loadCostMachine(short m,long long int &lc);
  void algo(void);
  void firstinit(void);

  char ficjeu[128];

  int inext, inextp;
  long ma[56];
  void srand3(int g);
  int rand3(void);


  long long int **cout;
  char **mkij;
  int *match_;
  int *tcham;
  int *nzl;

  int *leaf;
  int *visit;
  int *queue;
  int **succ;
  int *mki;
  int *mkj;

  int *dropM;

  void alloc_khun(int nc);

  int cpulimit;

  public:
  void solve(const char *modelFileName, const char *assignmentFileName, int cpulimit);
  void setX(unsigned int p, unsigned int m){ x[p] = m; }
  int getX(unsigned int p){ return x[p]; }
};
